#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <conio.h>
#include <windows.h>
#include <math.h>

#include "CmdHPGL.h"
#include "Tserial.h"

#define MAX_X 11999            //12000  d'aprs les dimensions de la CNC
#define MAX_Y 15999            //16000  d'aprs les dimensions de la CNC
#define MAX_Z 3000



// *********************** Afficher le mode en cours ******************

unsigned char TCommandeNum::CNC_Output_Current_Mode (Tserial * com)
{
    unsigned char MD[] = {0x1B,0x4D,0x44,0x3A,0x0D,0x1A};  // implmentation de MD
    unsigned char Receive[7];      // implmentation d'un tableau vide Receive
    while (! com->getCTS());
    com->sendArray (MD,6);
    while (com->getNbrOfBytes()!=7);    // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,7);          // rception de la chaine prsent dans le buffer d'entre
    if (Receive[0]!=0x1B) return ('N');
    if (Receive[1]!=0x4D) return ('N');
    if (Receive[2]!=0x44) return ('N');
    if (Receive[3]!=0x3A) return ('N');
    if (Receive[5]!=0x0D) return ('N');
    if (Receive[6]!=0x1A) return ('N');
    return Receive[4];
}

// *********************** Afficher la position ******************

void TCommandeNum::Get_Position (Tserial *com, unsigned char aoc_oc, int *X, int *Y, int *Z)
{
    unsigned char OC[] = {0x4F,0x43,0x3B,0x0D,0x1A};
    unsigned char aOC[] = {0x40,0x4F,0x43,0x3B,0x0D,0x1A};
    unsigned char Receive[32];

    while (! com->getCTS());
    if (aoc_oc==0)
        {
        com->sendArray (OC,5);        // requete d'emission de la position
        }

    if (aoc_oc==1)
        {
        com->sendArray (aOC,6);        // requete d'emission de la position
        }

    while (com->getNbrOfBytes()!=32); // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,32); // rception de la chaine prsent dans le buffer d'entre

    *X = (Receive[4]-'0')*10000 + (Receive[5]-'0')*1000 + (Receive[6]-'0')*100 + (Receive[7]-'0')*10 + (Receive[8]-'0');
    *Y = (Receive[14]-'0')*10000 + (Receive[15]-'0')*1000 + (Receive[16]-'0')*100 + (Receive[17]-'0')*10 + (Receive[18]-'0');
    *Z = (Receive[24]-'0')*10000 + (Receive[25]-'0')*1000 + (Receive[26]-'0')*100 + (Receive[27]-'0')*10 + (Receive[28]-'0');
}

// *********************** LM ******************

unsigned char TCommandeNum::SendRead_LM (Tserial *com)
{
    unsigned char LM[] = {0x1B,0x4C,0x4D,0x3A,0x0D,0x1A};
    unsigned char Receive[6];

    while (!(com->getCTS()));
    com->sendArray (LM,6);
    while (com->getCTS());
    while (com->getNbrOfBytes()!=6); // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,6); // rception de la chaine prsent dans le buffer d'entre

    if (Receive[0]!=0x1B) return 0;
    if (Receive[1]!=0x4C) return 0;
    if (Receive[2]!=0x4D) return 0;
    if (Receive[3]!=0x3A) return 0;
    if (Receive[4]!=0x0D) return 0;
    if (Receive[5]!=0x1A) return 0;

    return 1;
}

// *********************** LI ******************

unsigned char TCommandeNum::SendRead_LI (Tserial *com)
{
    unsigned char LI[] = {0x1B,0x4C,0x49,0x3A,0x0D,0x1A};
    unsigned char Receive[6];

    while (! com->getCTS());
    com->sendArray (LI,6);
    while (com->getCTS());
    while (com->getNbrOfBytes()!=6); // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,6); // rception de la chaine prsent dans le buffer d'entre

    if (Receive[0]!=0x1B) return 0;
    if (Receive[1]!=0x4C) return 0;
    if (Receive[2]!=0x49) return 0;
    if (Receive[3]!=0x3A) return 0;
    if (Receive[4]!=0x0D) return 0;
    if (Receive[5]!=0x1A) return 0;
    return 1;
}

// *********************** .) ******************

unsigned char TCommandeNum::SendRead_PAR (Tserial *com)
{
    unsigned char par[]= {0x1B,0x2E,0x29,0x0D,0x1A};

    while (! com->getCTS());
    com->sendArray (par,5);
    while (com->getCTS());

    return 1;
}

// *********************** LO ******************

unsigned char TCommandeNum::SendRead_LO (Tserial *com)
{
    unsigned char LO[] = {0x1B,0x4C,0x4F,0x3A,0x0D,0x1A};
    unsigned char Receive[6];

    while (! com->getCTS());
    com->sendArray (LO,6);
    while (com->getCTS());
    while (com->getNbrOfBytes()!=6); // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,6); // rception de la chaine prsent dans le buffer d'entre

    if (Receive[0]!=0x1B) return 0;
    if (Receive[1]!=0x4C) return 0;
    if (Receive[2]!=0x4F) return 0;
    if (Receive[3]!=0x3A) return 0;
    if (Receive[4]!=0x0D) return 0;
    if (Receive[5]!=0x1A) return 0;
    return 1;
}

// *********************** FM ******************

unsigned char TCommandeNum::SendRead_FM (Tserial *com)
{
    unsigned char FM[] = {0x1B,0x46,0x4D,0x3A,0x0D,0x1A};
    unsigned char Receive[6];

    while (! com->getCTS());
    com->sendArray (FM,6);
    while (com->getCTS());
    while (com->getNbrOfBytes()!=6); // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,6); // rception de la chaine prsent dans le buffer d'entre

    if (Receive[0]!=0x1B) return 0;
    if (Receive[1]!=0x46) return 0;
    if (Receive[2]!=0x4D) return 0;
    if (Receive[3]!=0x3A) return 0;
    if (Receive[4]!=0x0D) return 0;
    if (Receive[5]!=0x1A) return 0;
    return 1;
}

// *********************** .)<EOF> ******************

unsigned char TCommandeNum::SendRead_parEF (Tserial *com)
{
    unsigned char parEF[] = {0x1B,0x2E,0x29,0x1A,0x0D,0x1A};
    unsigned char Receive[6];

    while (! com->getCTS());
    com->sendArray (parEF,6);
    while (com->getCTS());
    while (com->getNbrOfBytes()!=6); // attend qu'il y ait le retour de la chaine
    com->getArray (Receive,6); // rception de la chaine prsent dans le buffer d'entre

    if (Receive[0]!=0x1B) return 0;
    if (Receive[1]!=0x2E) return 0;
    if (Receive[2]!=0x29) return 0;
    if (Receive[3]!=0x1A) return 0;
    if (Receive[4]!=0x0D) return 0;
    if (Receive[5]!=0x1A) return 0;
    return 1;
}

// *********************** Choix du mode ******************

void TCommandeNum::CNC_Select_Mode (Tserial * com, unsigned char sel)
{
//---------- MODE 0 : LOCAL ----------------
unsigned char Mode= CNC_Output_Current_Mode(com);

    if (Mode==0x30)
        {
        // --- Aller dans le mode DCC ---
        if (sel==1)
            {
            printf ("Changement de mode : Local --> DCC ... Status : %d\n",SendRead_LI (com));     // entrer dans le mode DCC
            }
        // --- Aller dans le mode HPGL line ---
        if (sel==2)
            {
            printf ("Changement de mode : Local --> HPGL line ... Status : %d\n",SendRead_LM (com));  // entrer dans le mode HPGL line
            }
        // --- Aller dans le mode HPGL file ---
        if (sel==3)
            {
            printf ("Changement de mode : Local --> HPGL File ... Status : %d\n",SendRead_FM (com));  // entrer dans le mode HPGL file
            }
        }


//--------- MODE 1 : DCC --------------------

    if (Mode==0x31)
        {
        // --- Aller dans le mode local ---
        if (sel==0)
            {
            printf ("Changement de mode : DCC --> Local ... Status : %d\n",SendRead_LO (com));  // entrer dans le mode local
            }
        // --- Aller dans le mode HPGL line ---
        if (sel==2)
            {
            printf ("Changement de mode : DCC --> HPGL line ... Status : %d\n",SendRead_LM (com));   // entrer dans le mode HPGL line
            }
        // --- Aller dans le mode HPGL file ---
        if (sel==3)
            {
            printf ("Changement de mode : Local --> HPGL File ... Status : %d\n",SendRead_FM (com));  // entrer dans le mode HPGL line
            }
        }

//--------- MODE 2 : HGPL Line --------------

    if (Mode==0x32)
        {
        // --- Aller dans le mode local ---
        if (sel==0)
            {
            printf ("Changement de mode : HPGL Line --> Local ... Status : %d\n",SendRead_PAR (com));    // entrer dans le mode local   (seul changement possible)
            }
        // --- Aller dans le mode DCC ---
        if (sel==1)
            {
            SendRead_PAR (com);
            printf ("Changement de mode : Local --> DCC ... Status : %d\n",SendRead_LI (com));     // entrer dans le mode DCC
            }
        // --- Aller dans le mode HPGL file ---
        if (sel==3)
            {
            SendRead_PAR (com);
            printf ("Changement de mode : Local --> HPGL File ... Status : %d\n",SendRead_FM (com));
            }
        }

//------- MODE 3 : HPGL File -------------------
    if (Mode==0x33)
        {
        // --- Aller dans le mode local ---
        if (sel==0)
            {
            printf ("Changement de mode : HPGL File --> Local ... Status : %d\n",SendRead_PAR (com));    // entrer dans le mode local   (seul changement possible)
            }
        // --- Aller dans le mode DCC ---
        if (sel==1)
            {
             SendRead_PAR (com);
             printf ("Changement de mode : Local --> DCC ... Status : %d\n",SendRead_LI (com));
            }
        // --- Aller dans le mode HPGL line ---
        if (sel==2)
            {
            SendRead_PAR (com);
            printf ("Changement de mode : Local --> HPGL Line ... Status : %d\n",SendRead_LM (com));
            }

        }
}

// *********************** Choix vitesse XY ******************

void TCommandeNum::Speed_XY (Tserial * com, int vit)
{
    unsigned char Vitesse[] = {0x56,0x53,0x20,0x36,0x30,0x2E,0x30,0x3B,0x0D,0x1A};   //VS

    Vitesse[3]=(vit/10)%10 + 0x30 ;
    Vitesse[4]=(vit)%10 + 0x30 ;

    while (! com->getCTS());
    com->sendArray (Vitesse,10);
    while (com->getCTS());
}

// *********************** Choix coordonnes absolues XY ******************

void TCommandeNum::Plot_Absolut (Tserial * com, int charx, int chary)
{
unsigned char PositionXY[] = {0x50,0x41,0x20,0x30,0x30,0x30,0x30,0x30,0x2C,0x20,0x30,0x30,0x30,0x30,0x30,0x3B,0x0D,0x1A};  //PA
unsigned char Mode=CNC_Output_Current_Mode(com);

if (Mode==0x32)
    {
    int X;
    int Y;

    X=charx*40;
    Y=chary*40;

    if ((X>=0)&(Y>=0)&(X<MAX_X)&(Y<MAX_Y))
        {

        PositionXY[3]=(X/10000)%10 + 0x30 ;
        PositionXY[4]=(X/1000)%10 + 0x30 ;
        PositionXY[5]=(X/100)%10 + 0x30 ;
        PositionXY[6]=(X/10)%10 + 0x30 ;
        PositionXY[7]= X%10 + 0x30 ;

        PositionXY[10]=(Y/10000)%10 + 0x30 ;
        PositionXY[11]=(Y/1000)%10 + 0x30 ;
        PositionXY[12]=(Y/100)%10 + 0x30 ;
        PositionXY[13]=(Y/10)%10 + 0x30 ;
        PositionXY[14]= Y%10 + 0x30 ;

        printf("En route vers la position : %s\n",PositionXY) ;

        while (!com->getCTS());
        com->sendArray (PositionXY,21);
        while (com->getCTS());
        printf ("Mouvement en XY effectue \n");
       }
    else printf ("Erreur : En dehors des limites !\n");
    }

    else printf ("Passez en mode 2 pour effectuer un deplacement \n");
}

// *********************** Choix dplacement relatif XY ******************

void TCommandeNum::Plot_Relative (Tserial * com, float charx, float chary)
{
unsigned char PositionXY[] = {0x50,0x52,0x20,0x30,0x30,0x30,0x30,0x30,0x30,0x2C,0x20,0x30,0x30,0x30,0x30,0x30,0x30,0x3B,0x0D,0x1A};  //PA
unsigned char Mode=CNC_Output_Current_Mode(com);
int X,Y,Posx,Posy,Posz;

X=charx*40;
Y=chary*40;

Get_Position (com,0,&Posx,&Posy,&Posz);

if (Mode==0x32)
    {
   if ((X>=0)&((X+Posx)<MAX_X))
        {
        PositionXY[4]=(X/10000)%10 + 0x30 ;
        PositionXY[5]=(X/1000)%10 + 0x30 ;
        PositionXY[6]=(X/100)%10 + 0x30 ;
        PositionXY[7]=(X/10)%10 + 0x30 ;
        PositionXY[8]= X%10 + 0x30 ;
        }

   if ((Y>=0)&((Y+Posy)<MAX_Y))
        {
        PositionXY[12]=(Y/10000)%10 + 0x30 ;
        PositionXY[13]=(Y/1000)%10 + 0x30 ;
        PositionXY[14]=(Y/100)%10 + 0x30 ;
        PositionXY[15]=(Y/10)%10 + 0x30 ;
        PositionXY[16]= Y%10 + 0x30 ;
        }

  if  ((X<0)&((X+Posx)>0))
        {
        X=-X;
        PositionXY[3]=0x2D ;
        PositionXY[4]=(X/10000)%10 + 0x30 ;
        PositionXY[5]=(X/1000)%10 + 0x30 ;
        PositionXY[6]=(X/100)%10 + 0x30 ;
        PositionXY[7]=(X/10)%10 + 0x30 ;
        PositionXY[8]= X%10 + 0x30 ;
        }

  if ((Y<0)&((Y+Posy)>0))
        {
        Y=-Y;
        PositionXY[11]=0x2D;
        PositionXY[12]=(Y/10000)%10 + 0x30 ;
        PositionXY[13]=(Y/1000)%10 + 0x30 ;
        PositionXY[14]=(Y/100)%10 + 0x30 ;
        PositionXY[15]=(Y/10)%10 + 0x30 ;
        PositionXY[16]= Y%10 + 0x30 ;
        }

    printf("%s\n",PositionXY);

    while (!com->getCTS());
    com->sendArray (PositionXY,21);
    printf ("Mouvement relatif en XY effectue \n");
    //else printf ("Erreur : En dehors des limites !\n");

    }
else printf ("Passez en mode 2 pour effectuer un deplacement \n");
}

// *********************** Choix dplacement absolu Z ******************

void TCommandeNum::Move_To_Z (Tserial * com, int charz)
{
unsigned char PositionZ[]={0x40,0x5A,0x41,0x20,0x30,0x30,0x30,0x30,0x3B,0x0D,0x1A};  //@ZA
unsigned char Mode=CNC_Output_Current_Mode(com);

if (Mode==0x32)
    {
    int Z = charz*40;

    if ((Z>=0)&(Z<=MAX_Z))
        {
        PositionZ[4]=(Z/1000)%10 + 0x30 ;
        PositionZ[5]=(Z/100)%10 + 0x30 ;
        PositionZ[6]=(Z/10)%10 + 0x30 ;
        PositionZ[7]= Z%10 + 0x30 ;

        printf("%s\n",PositionZ) ;

        while (!com->getCTS());
        com->sendArray (PositionZ,11);
        while (com->getCTS());
        printf ("Mouvement en Z effectue  \n");

       }
    else printf ("Erreur : En dehors des limites !\n");
    }
else printf ("Passez en mode 2 pour effectuer un deplacement\n");
}

// *********************** Cercle ******************

void TCommandeNum::Cercle (Tserial * com, int rayon, int precision)
{
unsigned char PA[]={0x50,0x41,0x20,0x30,0x30,0x30,0x30,0x30,0x2C,0x20,0x30,0x30,0x30,0x30,0x30,0x3B,0x0D,0x1A};
float i=0;
int X, Y, centreX=150*40, centreY=200*40;
rayon = rayon*40;

    X=cos(0)*rayon + centreX;
    Y=sin(0)*rayon + centreY;

    PA[3]=(X/10000)%10 + 0x30 ;
    PA[4]=(X/1000)%10 + 0x30 ;
    PA[5]=(X/100)%10 + 0x30 ;
    PA[6]=(X/10)%10 + 0x30 ;
    PA[7]= X%10 + 0x30 ;

    PA[10]=(Y/10000)%10 + 0x30 ;
    PA[11]=(Y/1000)%10 + 0x30 ;
    PA[12]=(Y/100)%10 + 0x30 ;
    PA[13]=(Y/10)%10 + 0x30 ;
    PA[14]= Y%10 + 0x30 ;

    com->sendArray (PA,21);

    Move_To_Z(com,75);

    for (i=0;i<=(63*precision);i++)
    {
    X=cos(i/(10*precision))*rayon + centreX;
    Y=sin(i/(10*precision))*rayon + centreY;


    PA[3]=(X/10000)%10 + 0x30 ;
    PA[4]=(X/1000)%10 + 0x30 ;
    PA[5]=(X/100)%10 + 0x30 ;
    PA[6]=(X/10)%10 + 0x30 ;
    PA[7]= X%10 + 0x30 ;

    PA[10]=(Y/10000)%10 + 0x30 ;
    PA[11]=(Y/1000)%10 + 0x30 ;
    PA[12]=(Y/100)%10 + 0x30 ;
    PA[13]=(Y/10)%10 + 0x30 ;
    PA[14]= Y%10 + 0x30 ;

    com->sendArray (PA,21);

    }
    Move_To_Z(com,0);
}

// -------------- Contouring Length of segment---------------------

void TCommandeNum::Send_aCL (Tserial *com, int length)
{
unsigned char aCL[]={0x40,0x43,0x4C,0x20,0x33,0x32,0x30,0x30,0x30,0x3B,0x0D,0x1A};

aCL[4]=(length/10000)%10 + 0x30 ;
aCL[5]=(length/1000)%10 + 0x30 ;
aCL[6]=(length/100)%10 + 0x30 ;
aCL[7]=(length/10)%10 + 0x30 ;
aCL[8]=(length%10) + 0x30 ;

while (! com->getCTS());

com->sendArray (aCL,12);
}

// -------------- Contouring angle set ---------------------

void TCommandeNum::Send_aCA (Tserial *com, int angle)
{
unsigned char aCA[]={0x40,0x43,0x41,0x20,0x39,0x30,0x3B,0x0D,0x1A};

aCA[4]=(angle/10)%10 + 0x30 ;
aCA[5]=(angle%10) + 0x30 ;

while (! com->getCTS());

com->sendArray (aCA,9);
}

// -------------- Vitesse verticale ---------------------

void TCommandeNum::Speed_Z (Tserial *com, int speed)
{
unsigned char aZD[]={0x40,0x5A,0x44,0x20,0x30,0x30,0x2E,0x30,0x3B,0x0D,0x1A};

aZD[4]=(speed/10)%10 + 0x30 ;
aZD[5]=(speed%10) + 0x30 ;

while (! com->getCTS());

com->sendArray (aZD,9);

}

//----------------- Reinitialisation --------------------

unsigned char TCommandeNum::Send_Reset (Tserial *com)
{
    unsigned char aHM[] = {0x40,0x48,0x4D,0x3B,0x0D,0x1A};
    unsigned char Receive[6];
    while (!(com->getCTS()));
    com->sendArray (aHM,6);
}

//----------------- Bouger avec le paver numrique --------------------

void TCommandeNum::Keyboard_Move (Tserial *com)
{
unsigned char val;
int X=0,Y=0,Z=0,pas=5;
val=getch();
if (val==0x34) Plot_Relative (com,0,pas); // vers la gauche
if (val==0x38) Plot_Relative (com,pas,0);   // vers le haut
if (val==0x36) Plot_Relative (com,0,-pas);    // vers la droite
if (val==0x32) Plot_Relative (com,-pas,0);      //  vers le bas
if (val==0x37) Plot_Relative (com,pas,pas);
if (val==0x39) Plot_Relative (com,pas,-pas);
if (val==0x31) Plot_Relative (com,-pas,pas);
if (val==0x33) Plot_Relative (com,-pas,-pas);
if (val==0x35)
    {
    Get_Position(com,0,&X,&Y,&Z);
    printf ("X : %d Y : %d Z : %d \n",X,Y,Z);
    }

if (val==0x2D) Move_To_Z (com,75);  // pen down
if (val==0x2B) Move_To_Z (com,70);   //pen up
if (val==0x2A) Send_Reset (com);  // pen off
}

void TCommandeNum::Plot_Relative_Z (Tserial * com, int charz)
{
unsigned char PositionZ[]={0x40,0x5A,0x52,0x20,0x30,0x30,0x30,0x30,0x3B,0x0D,0x1A};  //@ZA
unsigned char Mode=CNC_Output_Current_Mode(com);
int Z,Posx,Posy,Posz;


Z=charz*40;

Get_Position (com,0,&Posx,&Posy,&Posz);

if (Mode==0x32)
    {
   if ((Z>=0)&((Z+Posz)<MAX_Z))
        {
        PositionZ[4]=(Z/10000)%10 + 0x30 ;
        PositionZ[5]=(Z/1000)%10 + 0x30 ;
        PositionZ[6]=(Z/100)%10 + 0x30 ;
        PositionZ[7]=(Z/10)%10 + 0x30 ;
        PositionZ[8]= Z%10 + 0x30 ;
        }

   if ((Z<0)&((Z+Posz)>0))
        {
        Z=-Z;
        PositionZ[12]='-' ;
        PositionZ[13]=(Z/1000)%10 + 0x30 ;
        PositionZ[14]=(Z/100)%10 + 0x30 ;
        PositionZ[15]=(Z/10)%10 + 0x30 ;
        PositionZ[16]= Z%10 + 0x30 ;
        }
    }
}



void TCommandeNum::Interpolation_Test (Tserial * com)
{
    while (! com->getCTS());  // V   S   spce  6    0     ;  CR    LF    P   A   spce   0    ,   0    ;               @     Z   D   spce   6   0     .    0    ;             @    Z    A  spce   3    0     0   0    ;              V   S   spce   1    5    ;                                                                                        P    A  spce  1    0    0    0    ,    1     0   0    0    ;                P   A   spce   3    0    0    0    ,    0    ;
    unsigned char circle[] =  {0x56,0x53,0x20,0x36,0x30,0x3B,0x0D,0x0A,0x50,0x41,0x20,0x30,0x2C,0x30,0x3B,0x0D,0x0A,0x40,0x5A,0x44,0x20,0x36,0x30,0x2E,0x30,0x3B,0x0D,0x0A,0x40,0x5A,0x41,0x20,0x33,0x30,0x30,0x30,0x3B,0x0D,0x0A,0x56,0x53,0x20,0x31,0x35,0x3B,0x0D,0x0A,0x50,0x41,0x20,0x30,0x32,0x30,0x30,0x2C,0x30,0x32,0x30,0x30,0x3B,0x0D,0x0A,0x50,0x41,0x20,0x30,0x35,0x30,0x30,0x2C,0x30,0x34,0x30,0x30,0x3B,0x0D,0x0A,0x50,0x41,0x20,0x30,0x35,0x30,0x30,0x2C,0x30,0x35,0x30,0x30,0x3B,0x0D,0x0A,0x50,0x41,0x20,0x33,0x30,0x30,0x30,0x2C,0x36,0x30,0x30,0x3B,0x0D,0x0A,0x50,0x41,0x20,0x30,0x30,0x30,0x30,0x2C,0x30,0x3B,0x1A,0x0D};
    unsigned char courbe[] = {'V','S',' ','6','0','.','0',';',0x0D,0x0A,'P','A',' ','0',',','0',0x3B,0x0D,0x0A,0x40,0x5A,0x44,0x20,0x36,0x30,0x2E,0x30,0x3B,0x0D,0x0A,0x40,0x5A,0x41,0x20,0x33,0x30,0x30,0x30,0x3B,0x0D,0x0A,'V','S',' ','7','5','.','0',';',0x0D,0x0A,'P','A',' ','5','5','5',',','5','5','5',0x3B,0x0D,0x0A,'P','A',' ','5','5','5',',','1','5','5',0x3B,0x0D,0x0A,'P','A',' ','6','5','5',',','1','5','5',0x3B,0x0D,0x0A,'P','A',' ','9','5','5',',','2','5','5',0x3B,0x0D,0x0A,'P','A',' ','8','5','5',',','0','5','5',0x3B,0x0D,0x0A,'P','A',' ','7','5','5',',','2','5','5',0x3B,0x0D,0x0A,'P','A',' ','6','5','5',',','2','5','5',0x3B,0x0D,0x0A,'P','A',' ','9','5','5',',','3','5','5',0x3B,0x0D,0x0A,'P','A',' ','1','1','5','5',',','5','5','5',0x3B,0x0D,0x0A,'P','A',' ','1','5','5','5',',','6','5','5',0x3B,0x0D,0x0A};
    unsigned char test [] = {'P','A',':',' ','5','0','0',',','0',';',0x0D,0x0A};
    int lon = strlen (courbe);
    com->sendArray (courbe,lon);
}

